"""
Function of this code: one method of transforming DNA sequences to numerical values.
Contact for help: gch_liu@163.com 
"""

import numpy as np
def dna2numCGRcurve(seq):
    N=len(seq);
    m=np.zeros([N+1,2]);
    m[0,0]=0.5
    m[0,1]=0.5
    for i in range(1,N+1):
        if seq[i-1]=='T':
            m[i,0]=0.5*(m[i-1,0]+1);
            m[i,1]=0.5*(m[i-1,1]+0);
        elif seq[i-1]=='G':
            m[i,0]=0.5*(m[i-1,0]+1);
            m[i,1]=0.5*(m[i-1,1]+1);
        elif seq[i-1]=='C':
            m[i,0]=0.5*(m[i-1,0]+0);
            m[i,1]=0.5*(m[i-1,1]+1);
        else:   #seq(i)=='T';
            m[i,0]=0.5*(m[i-1,0]+0);
            m[i,1]=0.5*(m[i-1,1]+0);
    return m[1:,:];

if __name__=='__main__':
    print(dna2numCGRcurve("AGCTTGCA"))